Improper input validation in MDP driver when processing color maps (CVE-2014-4323)

Release Date: 
December 11, 2014
Advisory ID: 
QCIR-2014-00007-1
Summary: 

The following security vulnerability has been identified in the implementation of the MDP display driver for Android:

CVE-2014-4323:
The MDP display driver provides an ioctl system call interface to user space clients for communication. When processing this communication, the mdp_lut_hw_update function uses the user-supplied values start and len from an fb_cmap structure for write operations without any boundary checks. A local application with graphics privileges can access the MDP display device node and use this to, e.g., elevate privileges.

Access Vector: local
Security Risk: high
Vulnerability: CWE-20 (Improper input validation)

Affected versions:
All active branches of the MSM kernel for Android on CAF are affected. The driver itself is only used on the following chipsets: 8064/8960/8660/8x30/7x30.

Acknowledgement: 

Qualcomm Innovation Center, Inc. (QuIC) thanks Gal Beniamini for reporting the related issues and working with QuIC to help improve Android device security.

Revisions: 

Initial revision.

Contact: 
security-advisory@quicinc.com